
import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.ParserConfigurationException;
import java.io.IOException;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 * Die Klasse SAXLeser parsed eine XML Datei (arg[0]) 
 * und gibt sie mit SAXSchreiber wieder aus.
 * JDK &gt;= 1.4
 */

public class SAXLeser {

    public static void main(String[] args) {

	SAXParserFactory pfac = SAXParserFactory.newInstance();
	SAXParser parser = null;

	try {
	   pfac.setValidating(true);
	   pfac.setNamespaceAware(true);
	   parser = pfac.newSAXParser();
	}
	catch (ParserConfigurationException e) {
	    e.printStackTrace();
	}
	catch (SAXException e) {
	    e.printStackTrace();
	}

	Screen sc = new Screen();
        String uri = "datei.xhtml";
	if ( args.length > 0 ) uri = args[0];

	DefaultHandler dh = new SAXSchreiber(sc);

	try {
            parser.parse(uri,dh);
	}
	catch (SAXException e) {
	    e.printStackTrace();
	}
	catch (IOException e) {
	    e.printStackTrace();
	}
	//	sc.println();
    }

}
